classif<-function(donnees,chauff=300,chainetot=3000,thin=5,an0=5,bn0=1,nbn0MAJ=100,arho=0.1,brho=0.1,nbSAMS=3,nbGibbs=1)
{
##Libraries 
library(gtools) 
library(MCMCpack) 
library(coda)
library(mnormt)
library(Matrix)       
library(msm) 

n<-nrow(donnees)
k<-ncol(donnees)
donnees<-donnees*2*pi/360
stockEntropy<-NULL
stockrho<-NULL
##Initialization
rho<-rinvgamma(1,arho,brho)
sigma_0<-diag(2*k)
cosSigma0<-cos(2*pi/k)
sinSigma0<-sin(2*pi/k)
R<-matrix(c(cosSigma0,-sinSigma0,sinSigma0, cosSigma0),ncol=2,byrow=T)
sigma_0[1:2,]<-cbind(rho*diag(2),rho*t(R),rho*t(R**2),rho*t(R**3),rho*t(R**4))
sigma_0[3:4,]<-cbind(rho*R,(rho+1)*diag(2),rho*t(R),rho*t(R**2),rho*t(R**3))
sigma_0[5:6,]<-cbind(rho*(R**2),rho*R,(rho+1)*diag(2),rho*t(R),rho*t(R**2))
sigma_0[7:8,]<-cbind(rho*(R**3),rho*(R**2),rho*R,(rho+1)*diag(2),t(R))
sigma_0[9:10,]<-cbind(rho*(R**4),rho*(R**3),rho*(R**2),rho*R,(rho+1)*diag(2))
sigma_0<-as.matrix(nearPD(sigma_0)$mat)
Invsigma_0<-solve(sigma_0)   
tau<-rep(1,n)              
perm<-permutations(5,5,c(1:5),repeats=F)

muij<-matrix(0,ncol=2*k,nrow=n)
muij<-rmnorm(n,rep(0,10),sigma_0) 

r<-matrix(runif(k*n,0,1),nrow=n,ncol=k)     
r<-matrix(10,nrow=n,ncol=k)
n0<-rgamma(1,an0,bn0) 

#Initialization to compare the clusterings # 
Effectifs<-NULL 
Classifs<-NULL 
Chaine<-NULL    
K<-list(Classifs=Classifs,Effectifs=Effectifs,Chaine=Chaine)

Classifs<-rep(1,nrow(donnees))  
for (kk in 1:chainetot)
{   
  print(c(kk,chainetot))
  xij1<-r*cos(donnees)
  xij2<-r*sin(donnees)

  ### SAMS Sampler  (Dahl 2005, page 13)
   JeuTotal<-cbind(xij1[,1],xij2[,1],xij1[,2],xij2[,2],xij1[,3],xij2[,3],xij1[,4],xij2[,4],xij1[,5],xij2[,5])
  
   for (ii in 1:nrow(JeuTotal))##permutation on the dataset
   {pt<-perm[tau[ii],] 
    permInv<-c(which(pt==1),which(pt==2),which(pt==3),which(pt==4),which(pt==5))
    j<-1
    while((all(perm[j,]==permInv))==FALSE) {j<-j+1}
    JeuTotal[ii,]<-permutpascirc(JeuTotal[ii,],perm,j)
   }
    for (ll in 1:nbSAMS)
    { indices<-sample(1:nrow(donnees),2,replace=F)
      if (Classifs[indices[1]]==Classifs[indices[2]])
      { ##split
        S<-which(Classifs==Classifs[indices[1]])
        S<-S[(!S==indices[1])&(!S==indices[2])]
        S_i<-indices[1]
        S_j<-indices[2]
        ratioQ<-NULL
        if (length(S)>0)
        {for (i in 1:length(S))
          {  jeu<-JeuTotal[S[i],]
             Sigma_i<-as.matrix((solve(nearPD((1/length(S_i))*diag(2*k)+Invsigma_0)$mat) ))
             Sigma_j<-as.matrix((solve(nearPD((1/length(S_j))*diag(2*k)+Invsigma_0)$mat) ))
             if (length(S_i)==1)
              { Somme_i<-JeuTotal[S_i,]}
             else
              { Somme_i<-apply(JeuTotal[S_i,],2,mean)}
              if (length(S_j)==1)
              { Somme_j<-JeuTotal[S_j,]}
             else
              { Somme_j<-apply(JeuTotal[S_j,],2,mean)}
             PS_i<-(length(S_i)*dmnorm(jeu,as.vector(Sigma_i%*%Somme_i),diag(2*k)+Sigma_i))
             PS_j<-(length(S_j)*dmnorm(jeu,as.vector(Sigma_j%*%Somme_j),diag(2*k)+Sigma_j))
             ratioI<-PS_i/(PS_i+PS_j)
             if (is.na(ratioI)) {ratioI<-0.5}
             newgroup<-rbinom(1,1,ratioI) 
             if (newgroup==0) 
              { S_j<-c(S_j,S[i])
                ratioQ<-c(ratioQ,1-ratioI)
              }
              else   
              { S_i<-c(S_i,S[i])
                ratioQ<-c(ratioQ,ratioI)
              }
          }
        }
        else
           {  ratioQ<-1 
           }   
       #MH ratio (Dahl 2005, p 14) 
        fracQ<-1/prod(ratioQ)
        fracP<-1
        if (length(S_i)>length(S_j))
        { S_jtest<-NULL
          for (jj in 1:length(S_j))
            { if (length(S_jtest)==0)
              { Sigma_S<-as.matrix(solve(nearPD((1/length(S_i))*diag(2*k)+Invsigma_0)$mat))
                Somme_S<-apply(JeuTotal[S_i,],2,mean)
                fracP<-fracP*max(10**(-320),dmnorm(JeuTotal[S_j[jj],],rep(0,length(jeu)),sigma_0+diag(2*k)))/max(10**(-320),dmnorm(JeuTotal[S_j[jj],],as.vector(Sigma_S%*%Somme_S),as.matrix(nearPD(diag(2*k)+Sigma_S)$mat)))
               }
              else  
              { Sigma_j<-as.matrix((solve(nearPD((1/length(S_jtest))*diag(2*k)+Invsigma_0)$mat) ))
                Sigma_S<-as.matrix(solve(nearPD((1/(length(S_jtest)+length(S_i)))*diag(2*k)+Invsigma_0)$mat))
                if (length(S_jtest)==1)
                { Somme_j<-JeuTotal[S_jtest,]
                  Somme_S<-apply(JeuTotal[c(S_i,S_jtest),],2,mean)
                }
               else
                { Somme_j<-apply(JeuTotal[S_jtest,],2,mean)
                  Somme_S<-apply(JeuTotal[c(S_i,S_jtest),],2,mean)
                } 
                fracP<-fracP*max(10**(-320),dmnorm(JeuTotal[S_j[jj],],as.vector(Sigma_j%*%Somme_j),as.matrix(nearPD(diag(2*k)+Sigma_j)$mat)))/max(10**(-320),dmnorm(JeuTotal[S_j[jj],],as.vector(Sigma_S%*%Somme_S),as.matrix(nearPD(diag(2*k)+Sigma_S)$mat)))
               }
              S_jtest<-c(S_jtest,S_j[jj]) 
             }      
        }
        else
        { S_itest<-NULL
          for (jj in 1:length(S_i))
            { if (length(S_itest)==0)
              { Sigma_S<-as.matrix(solve(nearPD((1/length(S_j))*diag(2*k)+Invsigma_0)$mat))
                if (length(S_j)==1)
                { Somme_S<-JeuTotal[S_j,] }
                else
                {Somme_S<-apply(JeuTotal[S_j,],2,mean)}
                fracP<-fracP*max(10**(-320),dmnorm(JeuTotal[S_i[jj],],rep(0,length(jeu)),sigma_0+diag(2*k)))/max(10**(-320),dmnorm(JeuTotal[S_i[jj],],as.vector(Sigma_S%*%Somme_S),as.matrix(nearPD(diag(2*k)+Sigma_S)$mat)))
               }
              else  
              { Sigma_i<-as.matrix((solve(nearPD((1/length(S_itest))*diag(2*k)+Invsigma_0)$mat) ))
                Sigma_S<-as.matrix(solve(nearPD((1/(length(S_itest)+length(S_j)))*diag(2*k)+Invsigma_0)$mat))
                if (length(S_itest)==1)
                { Somme_i<-JeuTotal[S_itest,]
                  Somme_S<-apply(JeuTotal[c(S_j,S_itest),],2,mean)
                }
               else
                { Somme_i<-apply(JeuTotal[S_itest,],2,mean)
                  Somme_S<-apply(JeuTotal[c(S_j,S_itest),],2,mean)
                } 
                fracP<-fracP*max(10**(-320),dmnorm(JeuTotal[S_i[jj],],as.vector(Sigma_i%*%Somme_i),as.matrix(nearPD(diag(2*k)+Sigma_i)$mat)))/max(10**(-320),dmnorm(JeuTotal[S_i[jj],],as.vector(Sigma_S%*%Somme_S),as.matrix(nearPD(diag(2*k)+Sigma_S)$mat)))
               }
              S_itest<-c(S_itest,S_i[jj]) 
             }             
          }
      MHratio<-min(1,fracP*fracQ*gamma(length(S_i))*gamma(length(S_j))*n0/gamma(length(S_i)+length(S_j)))   
       if (is.na(MHratio)) {MHratio<-0.5}
      acceptchgmt<-rbinom(1,1,MHratio)   
       if (acceptchgmt==TRUE)
       {
        Classifs[S_i]<-Classifs[indices[1]]
        Classifs[S_j]<-max(Classifs)+1     
       }   
     }      
      else
        {  ##merge
          S_ifinal<-which(Classifs==Classifs[indices[1]])
          S_jfinal<-which(Classifs==Classifs[indices[2]])
          S<-sort(c(S_ifinal,S_jfinal))
          S<-S[(!S==indices[1])&(!S==indices[2])]
          S_i<-indices[1]
          S_j<-indices[2]
          ratioQ<-NULL
           #MH ratio (Dahl 2005, p 14) 
           if (length(S)>0)
           {  for (i in 1:length(S))
            {  jeu<-JeuTotal[S[i],]
             Sigma_i<-as.matrix((solve(nearPD((1/length(S_i))*diag(2*k)+Invsigma_0)$mat) ))
             Sigma_j<-as.matrix((solve(nearPD((1/length(S_j))*diag(2*k)+Invsigma_0)$mat) ))
             if (length(S_i)==1)
              { Somme_i<-JeuTotal[S_i,]}
             else
              { Somme_i<-apply(JeuTotal[S_i,],2,mean)}
              if (length(S_j)==1)
              { Somme_j<-JeuTotal[S_j,]}
             else
              { Somme_j<-apply(JeuTotal[S_j,],2,mean)}
             PS_i<-(length(S_i)*dmnorm(jeu,as.vector(Sigma_i%*%Somme_i),diag(2*k)+Sigma_i))
             PS_j<-(length(S_j)*dmnorm(jeu,as.vector(Sigma_j%*%Somme_j),diag(2*k)+Sigma_j))
             ratioI<-PS_i/(PS_i+PS_j)
             if (is.na(ratioI)) {ratioI<-0.5}
             if (S[i]%in%S_jfinal)  
               { S_j<-c(S_j,S[i])
                ratioQ<-c(ratioQ,1-ratioI)
              }
              else   
              { S_i<-c(S_i,S[i])
                ratioQ<-c(ratioQ,ratioI)
              }
             }
           }
           else
           {  ratioQ<-1 
           }  
           fracQ<-prod(ratioQ)
           fracP<-1
           if (length(S_i)>length(S_j))
           { S_jtest<-NULL
            for (jj in 1:length(S_j))
              { if (length(S_jtest)==0)
                { Sigma_S<-as.matrix(solve(nearPD((1/length(S_i))*diag(2*k)+Invsigma_0)$mat))
                  Somme_S<-apply(JeuTotal[S_i,],2,mean)
                  fracP<-fracP*max(10**(-320),dmnorm(JeuTotal[S_j[jj],],rep(0,length(jeu)),sigma_0+diag(2*k)))/max(10**(-320),dmnorm(JeuTotal[S_j[jj],],as.vector(Sigma_S%*%Somme_S),as.matrix(nearPD(diag(2*k)+Sigma_S)$mat)))
                 }
                else  
                { Sigma_j<-as.matrix((solve(nearPD((1/length(S_jtest))*diag(2*k)+Invsigma_0)$mat) ))
                  Sigma_S<-as.matrix(solve(nearPD((1/(length(S_jtest)+length(S_i)))*diag(2*k)+Invsigma_0)$mat))
                  if (length(S_jtest)==1)
                  { Somme_j<-JeuTotal[S_jtest,]
                    Somme_S<-apply(JeuTotal[c(S_i,S_jtest),],2,mean)
                  }
                 else
                  { Somme_j<-apply(JeuTotal[S_jtest,],2,mean)
                    Somme_S<-apply(JeuTotal[c(S_i,S_jtest),],2,mean)
                  } 
                  fracP<-fracP*max(10**(-320),dmnorm(JeuTotal[S_j[jj],],as.vector(Sigma_j%*%Somme_j),as.matrix(nearPD(diag(2*k)+Sigma_j)$mat)))/max(10**(-320),dmnorm(JeuTotal[S_j[jj],],as.vector(Sigma_S%*%Somme_S),as.matrix(nearPD(diag(2*k)+Sigma_S)$mat)))
                 }
                S_jtest<-c(S_jtest,S_j[jj]) 
               }      
          }
          else
          { S_itest<-NULL
            for (jj in 1:length(S_i))
              { if (length(S_itest)==0)
                { Sigma_S<-as.matrix(solve(nearPD((1/length(S_j))*diag(2*k)+Invsigma_0)$mat))
                  if (length(S_j)==1)
                  { Somme_S<-JeuTotal[S_j,] }
                  else
                  { Somme_S<-apply(JeuTotal[S_j,],2,mean)}
                  fracP<-fracP*max(10**(-320),dmnorm(JeuTotal[S_i[jj],],rep(0,length(jeu)),sigma_0+diag(2*k)))/max(10**(-320),dmnorm(JeuTotal[S_i[jj],],as.vector(Sigma_S%*%Somme_S),as.matrix(nearPD(diag(2*k)+Sigma_S)$mat)))
                 }
                else  
                { Sigma_i<-as.matrix((solve(nearPD((1/length(S_itest))*diag(2*k)+Invsigma_0)$mat) ))
                  Sigma_S<-as.matrix(solve(nearPD((1/(length(S_itest)+length(S_j)))*diag(2*k)+Invsigma_0)$mat))
                  if (length(S_itest)==1)
                  { Somme_i<-JeuTotal[S_itest,]
                    Somme_S<-apply(JeuTotal[c(S_j,S_itest),],2,mean)
                  }
                 else
                  { Somme_i<-apply(JeuTotal[S_itest,],2,mean)
                    Somme_S<-apply(JeuTotal[c(S_j,S_itest),],2,mean)
                  } 
                  fracP<-fracP*max(10**(-320),dmnorm(JeuTotal[S_i[jj],],as.vector(Sigma_i%*%Somme_i),as.matrix(nearPD(diag(2*k)+Sigma_i)$mat)))/max(10**(-320),dmnorm(JeuTotal[S_i[jj],],as.vector(Sigma_S%*%Somme_S),as.matrix(nearPD(diag(2*k)+Sigma_S)$mat)))
                 }
                S_itest<-c(S_itest,S_i[jj]) 
               }             
            }
           MHratio<-min(1,fracQ/(fracP*gamma(length(S_i))*gamma(length(S_j))*n0)*gamma(length(S_i)+length(S_j)))  
            if (is.na(MHratio)) {MHratio<-0.5}
           acceptchgmt<-rbinom(1,1,MHratio)  
           if (acceptchgmt==TRUE)   
           {
            Classifs[S_i]<-Classifs[indices[1]]
            Classifs[S_j]<-Classifs[indices[1]]     
           }                    
         }
   } ##end SAMS Sampler

   ##Gibbs Sampler (Dahl 2005 page 7)
  for (tt in 1:nbGibbs) 
  {  for (ii in 1:length(Classifs))
    { ClassifsT<-Classifs[-ii]
      jeu<-JeuTotal[ii,]
      PS_i<-NULL
      for (cc in 1:length(unique(ClassifsT)))
       { S_i<-which(ClassifsT==unique(ClassifsT)[cc])
         Sigma_i<-as.matrix((solve(nearPD((1/length(S_i))*diag(2*k)+Invsigma_0)$mat) ))
         if (length(S_i)==1)
         { Somme_i<-JeuTotal[S_i,]}
         else
         { Somme_i<-apply(JeuTotal[S_i,],2,mean)}        
         PS_i[unique(ClassifsT)[cc]]<-(length(S_i)*dmnorm(jeu,as.vector(Sigma_i%*%Somme_i),diag(2*k)+Sigma_i))
       }      
       PS_i<-c(PS_i,n0*dmnorm(jeu,rep(0,length(jeu)),as.matrix(nearPD(diag(2*k)+Invsigma_0)$mat))) ##ajout du gpe vide
       PS_i[is.na(PS_i)]<-0

       S1<-sum(PS_i)
       if (S1==0)
        { PS_i<-rep(1/length(PS_i),length(PS_i))}
       else 
        { PS_i<-PS_i/S1 }    
       Classifs[ii]<-which(rmultinom(1,1,PS_i)==1)
      }
   }
   ##phi
   ff<-unique(Classifs)
   ClassifsC<-Classifs
   for (jj in 1:length(ff))
   {  ClassifsC[which(Classifs==ff[jj])]<-jj }    
   Classifs<-ClassifsC
   
   Gpe<-unique(Classifs)
   Phi<-matrix(0,nrow=max(Gpe),ncol=10)
   for (yy in 1:length(Gpe))
   { S_i<-which(Classifs==Gpe[yy])
     Sigma_i<-as.matrix((solve(nearPD((1/length(S_i))*diag(2*k)+Invsigma_0)$mat) ))
     if (length(S_i)==1)
     { Somme_i<-JeuTotal[S_i,]}
     else
     { Somme_i<-apply(JeuTotal[S_i,],2,mean)} 
     Phi[yy,]<-rmnorm(1,as.vector(Sigma_i%*%Somme_i),Sigma_i)   
   } 
   muij<-Phi[Classifs,]

  #tau
  for (i in 1:n)
  {   jeu<-JeuTotal[i,]
      probatau<-NULL
 
     for (j in 1:nrow(perm))
     {   
      probatau[j]<-dmnorm(jeu,permutpascirc(muij[i,],perm,j),diag(2*k)) 
      }

    S1<-sum(probatau)
    if (S1==0)
      { probatau<-rep(1/length(probatau),length(probatau))}
    else 
     { probatau<-probatau/sum(probatau) }    
   tau[i]<-which(rmultinom(1,1,probatau)==1)
  }
  
   #r
   uij1<-cos(donnees)
   uij2<-sin(donnees) 
   for(i in 1:n)
   {  
      for (j in 1:k)  
      { rprop<-rtnorm(1,mean=sum(c(uij1[i,j],uij2[i,j])*permutpascirc(muij[i,],perm,tau[i])[j]),sd=1,lower=0)
        if (rbinom(1,1,min(rprop/r[i,j],1))==1){r[i,j]<-rprop}
      if (r[i,j]>10000) {r[i,j]<-10000}
      }      
   }

  #rho   
  mutilde<-unique(muij)
  ktilde<-nrow(mutilde)
  rho<-rinvgamma(1,arho+ktilde,brho+0.5*sum(mutilde[,1:2]**2))
  sigma_0[1:2,]<-cbind(rho*diag(2),rho*t(R),rho*t(R**2),rho*t(R**3),rho*t(R**4))
  sigma_0[3:4,]<-cbind(rho*R,(rho+1)*diag(2),rho*t(R),rho*t(R**2),rho*t(R**3))
  sigma_0[5:6,]<-cbind(rho*(R**2),rho*R,(rho+1)*diag(2),rho*t(R),rho*t(R**2))
  sigma_0[7:8,]<-cbind(rho*(R**3),rho*(R**2),rho*R,(rho+1)*diag(2),t(R))
  sigma_0[9:10,]<-cbind(rho*(R**4),rho*(R**3),rho*(R**2),rho*R,(rho+1)*diag(2))
  if ((any(sigma_0==Inf)|any(is.na(sigma_0))))
  {browser()}
  else{
  sigma_0<-as.matrix(nearPD(sigma_0)$mat) }  

  if(kk> chauff)  
  {#store the clustering
    cl<-compare(muij)
    save(cl,file="cl.Rdata")
    trouve<-FALSE
    l<-0
    K$Chaine<-rbind(K$Chaine,cl)     
    if ((kk%%thin ==0))
    { #clustering entropy  (Dahl 2005 page 18)   
      Entropy<-(-sum(table(Classifs)/length(Classifs)*log(table(Classifs)/length(Classifs))))
      stockEntropy<-c(stockEntropy,Entropy)
     # save(stockEntropy,file="Entropy.Rdata")
      
      stockrho<-c(stockrho,rho)
    #  save(stockrho,file="rho.Rdata")  
 
    #is this clustering already existing ?
      while ((trouve==FALSE)&(l<max(1,(nrow(K$Classifs))))&(kk>chauff+thin) )
      { l<-l+1 
       trouve=all(cl==K$Classifs[l,])
      }
  
      if (trouve==T)
      { K$Effectifs[l]<- K$Effectifs[l]+1 
      }
      else 
      {   K$Classifs<-rbind(K$Classifs,cl)
         K$Effectifs<-c(K$Effectifs,1)
      }    
    }
      #n0   (escobar/west jasa 95)
 n0<-n0MAJ(n0,an0,bn0,max(cl),n,nbn0MAJ) 
   }
}
 return(K)
}

permut<-function(vect,p=1)
{
  n<-length(vect)
  tp<-(seq(1:n)+p)%%n
  tp[which(tp==0)]=n
  return(vect[tp])
  
}

permutpascirc<-function(vect,perm,p=1)
{
  n<-length(vect)
  vectsort<-vect
  permafaire<-perm[p,]
  for (i in 1:length(permafaire))
  {
    vectsort[(i*2-1):(i*2)]<-vect[(permafaire[i]*2-1):(permafaire[i]*2)]  
  }
  return(vectsort)
}

compare<-function(donnees)
{
  n<-nrow(donnees)
  k<-0
  gpe<-rep(0,n)
  
  while ( length(which(gpe==0)>0)) 
  {  k<-k+1 
  pasdegpe<-which(gpe==0)
  npas<-length(pasdegpe)
  for (j in 1:npas)
  {  testgpe<-all(donnees[pasdegpe[1],]==donnees[pasdegpe[j],])
  
  if (testgpe)
  { gpe[pasdegpe[j]]=k }
  }
  }
  return(gpe)
  
}

n0MAJ<-function(n0,a,b,nbgpes,taille,nb=100)
{#n0 p585 d'Escobar/West JASA 95
  neta<-rbeta(nb,n0+1,taille)
  T<-(a+nbgpes-1)/(taille*(b-log(neta)))
  
  Pin<-T/(T+1)
  Cn<-1-Pin
  W<-which(rmultinom(1,1,c(Pin,Cn)/nb)==1)
  if (W<=nb)
  { n0<-rgamma(1,a+nbgpes,b-log(neta[W])) }
  else
  { n0<-rgamma(1,a+nbgpes-1,b-log(neta[W-nb])) }
  
  return(n0)
  
}

adapt<-function(donnees)
{
  if (ncol(donnees)==5)
  { n<-nrow(donnees)
  d<-ncol(donnees)
  ord<-matrix(0,ncol=d,nrow=n)
  jeu<-matrix(0,ncol=6,nrow=n)
  
  for (i in 1:n)
  { ord[i,]<-donnees[i,order(donnees[i,])]
  
  jeu[i,]<-c(ord[i,],360)-c(0,ord[i,])
  }
  }
  else
  { jeu<-(donnees)
  }
  for (j in 1:nrow(jeu))
  { 
    jeu[j,]<-replace(jeu[j,],which(jeu[j,]==0),10**(-100))
  }
  return(jeu)
}

